require 'test_helper'

class AccountTest < EssentialTest

  def test_invalid_credentials
    error = assert_raises Essential::APIError do
      Essential::Account.retrieve(headers: {sid: 'sid_nope'})
    end
    assert_equal 401, error.http_status
  end

  def test_valid_credentials
    account = Essential::Account.retrieve

    prefixed_sid = Essential.sid
    prefixed_sid = 'ac_' << prefixed_sid unless 0 == prefixed_sid.index('ac_')

    assert_equal prefixed_sid, account.sid
    assert_equal Essential.token, account.token
    refute_nil account.name
  end
end
