require 'test_helper'

class TransportTest < EssentialTest
  include Essential::Messaging

  def setup
    @first = Transport.list.first
  end

  def test_retrieve
    found = Transport.retrieve(@first.sid)

    assert_equal found, @first
  end

  def test_list
    all = Transport.list

    all_sids = all.map(&:sid)

    assert all_sids.include?(@first.sid)
    assert_equal all_sids.size, all.size
  end

  def test_relations
    mess = @first.messages
    refute_equal 0, mess.size
    assert mess.all? {|m| Message === m}

    subs = @first.subscribers
    refute_equal 0, subs.size
    assert subs.all? {|s| Subscriber === s}

    channel = @first.channel
    assert_equal @first.channel_sid, channel.sid
  end
end
