require 'minitest/autorun'
require 'essential'

require 'securerandom'
require 'set'

if ENV.key?('ESSENTIAL_SID') && ENV.key?('ESSENTIAL_TOKEN')
  $debug = false
  Essential.api_base = ENV['ESSENTIAL_URL'] || 'http://127.0.0.1:3000'
  Essential.sid = ENV['ESSENTIAL_SID']
  Essential.token = ENV['ESSENTIAL_TOKEN']
else
  # TODO: # require 'webmock/minitest'
  # mock all responses?
end

class EssentialTest < Minitest::Test

  protected

  def assert_error_with_params(*params, &_)
    error = assert_raises Essential::APIError do
      yield
    end

    refute_nil error.params, 'APIError must have params'

    expected_params = Set.new(params.map(&:to_s))
    actual_params   = Set.new(error.params.keys.map(&:to_s))

    assert_equal expected_params, actual_params, 'APIError params must match exactly'
  end

end
